VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Connect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Restore Project Add-In"
Option Explicit

Implements IDTExtensibility

Public VBInstance As VBIDE.VBE

Private mcbMenuCommandBarCtrl As Office.CommandBarControl
Private WithEvents MenuHandler As CommandBarEvents
Attribute MenuHandler.VB_VarHelpID = -1
Private gbRestore As Boolean

Private Const STR_RELOAD = "Reload last project on startup"
Private Const STR_NORELOAD = "Don't reload last project on startup"
Private Const STR_APP = "RestoreAddin"
Private Const STR_SECTION = "Parameters"
Private Const STR_KEY = "Reload"
Private Const STR_VB6 = "Software\Microsoft\Visual Basic\6.0"
Private Const BMP_RELOAD = 100
Private Const BMP_NORELOAD = 101

Private Type COLORMAP
    from As Long
    to As Long
End Type

Private Declare Function CreateMappedBitmap _
                    Lib "comctl32.dll" (ByVal hInstance As Long, _
                    ByVal idBitmap As Long, _
                    ByVal wFlags As Long, _
                    lpColorMap As COLORMAP, _
                    ByVal iNumMaps As Long) As Long

Const COLOR_MENU = 4

Private Type PICTDESC
    Size As Long
    Type As Long
    hBmp As Long
    hPal As Long
    Reserved As Long
End Type

Private Type IID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type

Private Declare Function OleCreatePictureIndirect _
                    Lib "olepro32.dll" (desc As PICTDESC, RefIID As IID, _
                    ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long

Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long

Dim g_map As COLORMAP
Function BitmapToPicture(ByVal hBmp As Long, _
                         Optional ByVal hPal As Long = 0) As IPicture

    ' Code adapted from HardCore Visual Basic articles in MSDN
    ' Fill picture description
    Dim IPic As IPicture, picdes As PICTDESC, iidIPicture As IID
    
    picdes.Size = Len(picdes)
    picdes.Type = vbPicTypeBitmap
    picdes.hBmp = hBmp
    picdes.hPal = hPal
    
    ' Fill in magic IPicture GUID {7BF80980-BF32-101A-8BBB-00AA00300CAB}
    iidIPicture.Data1 = &H7BF80980
    iidIPicture.Data2 = &HBF32
    iidIPicture.Data3 = &H101A
    iidIPicture.Data4(0) = &H8B
    iidIPicture.Data4(1) = &HBB
    iidIPicture.Data4(2) = &H0
    iidIPicture.Data4(3) = &HAA
    iidIPicture.Data4(4) = &H0
    iidIPicture.Data4(5) = &H30
    iidIPicture.Data4(6) = &HC
    iidIPicture.Data4(7) = &HAB
    
    ' Create picture from bitmap handle
    OleCreatePictureIndirect picdes, iidIPicture, True, IPic
    Set BitmapToPicture = IPic
    
End Function

Private Sub IDTExtensibility_OnConnection(ByVal VBInst As Object, ByVal ConnectMode As vbext_ConnectMode, ByVal AddInInst As VBIDE.AddIn, custom() As Variant)
    
    'Save the vb instance
    Set VBInstance = VBInst
    
    'Add Add-In to Tools menu
    Set mcbMenuCommandBarCtrl = VBInstance.CommandBars("Tools").Controls.Add(before:=3)
    mcbMenuCommandBarCtrl.BeginGroup = True
    
    g_map.from = RGB(192, 192, 192)
    g_map.to = GetSysColor(COLOR_MENU)
    
    'Set global option variable
    gbRestore = GetSetting(STR_APP, STR_SECTION, STR_KEY, "1") = "1"
    If gbRestore Then
        mcbMenuCommandBarCtrl.Caption = STR_NORELOAD
        Clipboard.SetData BitmapToPicture(CreateMappedBitmap(App.hInstance, BMP_NORELOAD, 0, g_map, 1))
    Else
        mcbMenuCommandBarCtrl.Caption = STR_RELOAD
        Clipboard.SetData BitmapToPicture(CreateMappedBitmap(App.hInstance, BMP_RELOAD, 0, g_map, 1))
    End If
    'Add icon to menu
    mcbMenuCommandBarCtrl.PasteFace
    'Very frankly, can you imagine a more awkward way of loading the icon?
    'The CommandBar control should have an adequate property or method
    
    'Set menu event handler
    Set MenuHandler = VBInstance.Events.CommandBarEvents(mcbMenuCommandBarCtrl)
    
    VBInstance.CommandBars("Tools").Controls(4).BeginGroup = True
    
End Sub

Private Sub IDTExtensibility_OnDisconnection(ByVal RemoveMode As vbext_DisconnectMode, custom() As Variant)

Dim sValue As String

    'Store current value of option before disconnection
    If gbRestore Then sValue = "1" Else sValue = "2"
    SaveSetting STR_APP, STR_SECTION, STR_KEY, sValue
    
    mcbMenuCommandBarCtrl.Delete
    
End Sub

Private Sub IDTExtensibility_OnStartupComplete(custom() As Variant)

Dim KeyValue As String
Dim AddInItem
Dim NewProjects
Dim Proj
Dim bPrompt As Boolean
Dim nProjIndex As Integer

    'Determine whether we load a default project
    bPrompt = True
    If GetKeyValue(HKEY_CURRENT_USER, STR_VB6, "PromptForProjectOnStartup", KeyValue) Then
        bPrompt = (KeyValue <> "0")
    End If
    
    'Exit if reloading not needed nor desired
    If (Not gbRestore) Or (bPrompt And VBInstance.VBProjects.Count > 0) Then
        Exit Sub
    End If
    
    If (Not bPrompt) And (VBInstance.VBProjects.Count > 0) Then
        If VBInstance.VBProjects(1).Name <> "Project1" Then Exit Sub
    End If
        
    nProjIndex = 1
    'Get last valid project from registry
    Do While GetKeyValue(HKEY_CURRENT_USER, STR_VB6 & "\RecentFiles", CStr(nProjIndex), KeyValue)
        If FileExists(KeyValue) Then    ' Check file existence
            'Make an exclusive Add Project
            NewProjects = VBInstance.VBProjects.AddFromFile(KeyValue, True)
            Exit Do
        Else
            nProjIndex = nProjIndex + 1
        End If
    Loop

End Sub

Private Sub IDTExtensibility_OnAddInsUpdate(custom() As Variant)
'
End Sub

Private Sub MenuHandler_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)

    'Toggle option value
    gbRestore = Not gbRestore
    'Change menu item string and icon
    If gbRestore Then
        mcbMenuCommandBarCtrl.Caption = STR_NORELOAD
        Clipboard.SetData BitmapToPicture(CreateMappedBitmap(App.hInstance, BMP_NORELOAD, 0, g_map, 1))
    Else
        mcbMenuCommandBarCtrl.Caption = STR_RELOAD
        Clipboard.SetData BitmapToPicture(CreateMappedBitmap(App.hInstance, BMP_RELOAD, 0, g_map, 1))
    End If
    mcbMenuCommandBarCtrl.PasteFace
End Sub

